MODULE FileSearcher;

FROM SYSTEM IMPORT BDOS, BDOSCALL;

CONST
  DMA : CARDINAL = 0x0080; (* Default DMA-Buffer Adresse *)
  
VAR
  fcb : ARRAY [0..36] OF CHAR;
  drive : CHAR;
  driveNumber : CARDINAL;
  user : CARDINAL;
  res : CARDINAL;
  wildcard : ARRAY [0..12] OF CHAR;
  
PROCEDURE SetDMA(addr : CARDINAL);
BEGIN
  BDOSCALL(26, addr);
END SetDMA;

PROCEDURE SetUser(u : CARDINAL);
BEGIN
  BDOSCALL(32, u);
END SetUser;

PROCEDURE SelectDisk(d : CARDINAL) : CARDINAL;
BEGIN
  RETURN BDOSCALL(14, d);
END SelectDisk;

PROCEDURE SearchFirst(pattern : POINTER TO CHAR) : CARDINAL;
BEGIN
  RETURN BDOSCALL(17, pattern);
END SearchFirst;

PROCEDURE SearchNext() : CARDINAL;
BEGIN
  RETURN BDOSCALL(18, NIL);
END SearchNext;

PROCEDURE PrintString(s : POINTER TO CHAR);
VAR
  i : CARDINAL;
BEGIN
  i := 0;
  WHILE s^[i] # 0C DO
    BDOSCALL(2, ORD(s^[i]));
    INC(i);
  END;
END PrintString;

PROCEDURE NewLine;
BEGIN
  BDOSCALL(2, ORD(0DH));
  BDOSCALL(2, ORD(0AH));
END NewLine;

PROCEDURE DisplayFoundFile;
VAR
  i : CARDINAL;
BEGIN
  FOR i := 1 TO 8 DO
    BDOSCALL(2, ORD(SYSTEM.VAL(POINTER TO CHAR, DMA)^[i]));
  END;
  BDOSCALL(2, ORD('.'));
  FOR i := 9 TO 11 DO
    BDOSCALL(2, ORD(SYSTEM.VAL(POINTER TO CHAR, DMA)^[i]));
  END;
  NewLine;
END DisplayFoundFile;

BEGIN
  (* Abfrage der Wildcards vom Benutzer *)
  PrintString('Enter search pattern (e.g., *.COM): ');
  
  (* Hier sollte man ein Eingabeprocedere einsetzen, z.B. mit BDOSCALL(10, Adresse) *)
  (* Vereinfachung: Muster hart kodiert *)
  wildcard := '*.COM' + 0C;

  SetDMA(DMA);

  FOR driveNumber := 0 TO 15 DO
    IF SelectDisk(driveNumber) = driveNumber THEN
      drive := CHR(ORD('A') + driveNumber);
      
      FOR user := 0 TO 15 DO
        SetUser(user);
        
        (* Suchmuster vorbereiten: Laufwerksbuchstaben anhängen *)
        fcb[0] := drive;
        fcb[1] := ':';
        (* Muster kopieren *)
        SYSTEM.MOVE(ADR(wildcard), ADR(fcb[2]), 13);
        fcb[15] := 0C; (* Terminator *)

        (* Suche starten *)
        res := SearchFirst(ADR(fcb));
        WHILE res = 0 DO
          (* Datei ausgeben *)
          BDOSCALL(2, ORD(drive));
          BDOSCALL(2, ORD(':'));
          BDOSCALL(2, ORD('0') + user);
          BDOSCALL(2, ORD(':'));
          DisplayFoundFile;
          
          res := SearchNext();
        END;
        
      END;
    END;
  END;
  
  (* Abschlussmeldung *)
  PrintString('Search complete.');
  NewLine;
  
END FileSearcher.
